
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dir.h>

FILE *fs,*fd;
char fns[256];
char Line[132];


int process(void)
{
 int ln,hn,lc,n,k;
 char *p;

  fprintf(fd,"unsigned char FPGABITS[] = \n{\n\t");
  lc=0;
  for (;;) {
    if (fgets(Line,128,fs)==NULL) break;
    if (*Line!=':') continue;
    strupr(Line);
    p=Line+1;
    hn=(*p++)-'0'; if (hn>15) hn-=7;
    ln=(*p++)-'0'; if (ln>15) ln-=7;
    n=(hn<<4)|ln;
    p+=5;
    if (*p=='2') continue;
    if (*p=='1') break;
    p++;
    while (n--) {
      hn=(*p++)-'0'; if (hn>15) hn-=7;
      ln=(*p++)-'0'; if (ln>15) ln-=7;
      k=(hn<<4)|ln;
      fprintf(fd,"0x%02x,",k); lc++;
      if (lc>=12) { fprintf(fd,"\n\t"); lc=0; }
     }
   }
  if (lc) fprintf(fd,"\n");
  fprintf(fd,"};\n");
  return(0);
}


int main(int argc,char *argv[])
{
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 char file[MAXFILE];
 char ext[MAXEXT];
 int  flags;

  if (argc<2) {
    printf("Use: MCS2I <file>.mcs\n"); exit(1);
   }
  flags=fnsplit(argv[1],drive,dir,file,ext);
  fnmerge(fns,drive,dir,file,".mcs");

  if ((fs=fopen(fns,"rt"))==NULL) {
    printf("No file %s\n",fns); exit(1);
   }
  fd=fopen("fpgabits.i","wt");

  process();

  fcloseall();
  return(0);
}

