
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "../dtc2.h"

FILE *fd;

int ports[] = { 0, 0x3bc, 0x378, 0x100 };


static unsigned char rlink(void)
{
  while ((inportb(C012+2)&1)==0);
  return(inportb(C012));
}

static void wlink(unsigned char b)
{
 unsigned t;

  t=0xffff; while (((inportb(C012+3)&1)==0)&&(--t));
  outportb(C012+1,b);
}


int main(void)
{
 int i,port,ofs,dir;
 unsigned char bh,bl;

  outportb(0x61,inportb(0x61)|0x0c);
  outportb(0x70,inportb(0x70)|0x80);
  outportb(0xa1,inportb(0xa1)|2);
  outportb(FPGA,0);

  for (i=0; i<4; i++) wlink(0);
  if ((inportb(C012+2)&1)==0) {
    for (i=0; i<2; i++) wlink(0);
   }
  if ((inportb(C012+2)&1)==0) {
    printf("No answer from T5\n"); exit(1);
   }

  fd=fopen("capt.log","wt");
  i=0;
  for (;;) {
    bh=rlink(); bl=rlink();
    if ((bh==0)&&(bl==0)) {
      bh=rlink(); bl=rlink();
      if ((bh==0)&&(bl==0)) break;
     }
    ofs=bh&3; dir=bh&0x40;
    port=ports[(bh>>3)&3]|ofs;
    if (ofs==1) bl&=0xf8;
     else if (ofs==2) bl&=0x0f;
    fprintf(fd,"Port %04x %s %02x",port,(dir? "read ":"write"),bl);
    if (bh&0x80) fprintf(fd,"\tERR");
    fprintf(fd,"\n"); i++;
    if (i==100) { printf("."); i=0; }
   }
  printf("Done\n");
  fclose(fd);
  outportb(0x160,1);
  delay(100);
  outportb(0x160,0);

  return(0);
}

